diff --git a/src/allmydata/test/test_download.py b/src/allmydata/test/test_download.py
index 3a69220..4d0e364 100644
--- a/src/allmydata/test/test_download.py
+++ b/src/allmydata/test/test_download.py
@@ -1214,14 +1214,16 @@ class Status(unittest.TestCase):
         now = 12345.1
         ds = DownloadStatus("si-1", 123)
         self.failUnlessEqual(ds.get_status(), "idle")
-        ds.add_segment_request(0, now)
+        ev0 = ds.add_segment_request(0, now)
         self.failUnlessEqual(ds.get_status(), "fetching segment 0")
-        ds.add_segment_delivery(0, now+1, 0, 1000, 2.0)
+        ev0.activate(now+0.5)
+        ev0.deliver(now+1, 0, 1000, 2.0)
         self.failUnlessEqual(ds.get_status(), "idle")
-        ds.add_segment_request(2, now+2)
-        ds.add_segment_request(1, now+2)
+        ev2 = ds.add_segment_request(2, now+2)
+        del ev2 # hush pyflakes
+        ev1 = ds.add_segment_request(1, now+2)
         self.failUnlessEqual(ds.get_status(), "fetching segments 1,2")
-        ds.add_segment_error(1, now+3)
+        ev1.error(now+3)
         self.failUnlessEqual(ds.get_status(),
                              "fetching segment 2; errors on segment 1")
 
diff --git a/src/allmydata/test/test_web.py b/src/allmydata/test/test_web.py
index f68e98d..b4b8bdc 100644
--- a/src/allmydata/test/test_web.py
+++ b/src/allmydata/test/test_web.py
@@ -19,7 +19,7 @@ from allmydata.nodemaker import NodeMaker
 from allmydata.unknown import UnknownNode
 from allmydata.web import status, common
 from allmydata.scripts.debug import CorruptShareOptions, corrupt_share
-from allmydata.util import fileutil, base32
+from allmydata.util import fileutil, base32, hashutil
 from allmydata.util.consumer import download_to_data
 from allmydata.util.netstring import split_netstring
 from allmydata.util.encodingutil import to_str
@@ -78,34 +78,38 @@ def build_one_ds():
     ds = DownloadStatus("storage_index", 1234)
     now = time.time()
 
-    ds.add_segment_request(0, now)
-    # segnum, when, start,len, decodetime
-    ds.add_segment_delivery(0, now+1, 0, 100, 0.5)
-    ds.add_segment_request(1, now+2)
-    ds.add_segment_error(1, now+3)
+    serverid_a = hashutil.tagged_hash("foo", "serverid_a")[:20]
+    serverid_b = hashutil.tagged_hash("foo", "serverid_b")[:20]
+    storage_index = hashutil.storage_index_hash("SI")
+    e0 = ds.add_segment_request(0, now)
+    e0.activate(now+0.5)
+    e0.deliver(now+1, 0, 100, 0.5) # when, start,len, decodetime
+    e1 = ds.add_segment_request(1, now+2)
+    e1.error(now+3)
     # two outstanding requests
-    ds.add_segment_request(2, now+4)
-    ds.add_segment_request(3, now+5)
+    e2 = ds.add_segment_request(2, now+4)
+    e3 = ds.add_segment_request(3, now+5)
 
     # simulate a segment which gets delivered faster than a system clock tick (ticket #1166)
-    ds.add_segment_request(4, now)
-    ds.add_segment_delivery(4, now, 0, 140, 0.5)
+    e = ds.add_segment_request(4, now)
+    e.activate(now)
+    e.deliver(now, 0, 140, 0.5)
 
-    e = ds.add_dyhb_sent("serverid_a", now)
+    e = ds.add_dyhb_request(serverid_a, now)
     e.finished([1,2], now+1)
-    e = ds.add_dyhb_sent("serverid_b", now+2) # left unfinished
+    e = ds.add_dyhb_request(serverid_b, now+2) # left unfinished
 
     e = ds.add_read_event(0, 120, now)
     e.update(60, 0.5, 0.1) # bytes, decrypttime, pausetime
     e.finished(now+1)
     e = ds.add_read_event(120, 30, now+2) # left unfinished
 
-    e = ds.add_request_sent("serverid_a", 1, 100, 20, now)
+    e = ds.add_block_request(serverid_a, 1, 100, 20, now)
     e.finished(20, now+1)
-    e = ds.add_request_sent("serverid_a", 1, 120, 30, now+1) # left unfinished
+    e = ds.add_block_request(serverid_a, 1, 120, 30, now+1) # left unfinished
 
     # make sure that add_read_event() can come first too
-    ds1 = DownloadStatus("storage_index", 1234)
+    ds1 = DownloadStatus(storage_index, 1234)
     e = ds1.add_read_event(0, 120, now)
     e.update(60, 0.5, 0.1) # bytes, decrypttime, pausetime
     e.finished(now+1)
@@ -554,10 +558,25 @@ class Web(WebMixin, WebErrorMixin, testutil.StallMixin, testutil.ReallyEqualMixi
         def _check_dl(res):
             self.failUnless("File Download Status" in res, res)
         d.addCallback(_check_dl)
-        d.addCallback(lambda res: self.GET("/status/down-%d?t=json" % dl_num))
+        d.addCallback(lambda res: self.GET("/status/down-%d/event_json" % dl_num))
         def _check_dl_json(res):
             data = simplejson.loads(res)
             self.failUnless(isinstance(data, dict))
+            self.failUnless("read" in data)
+            self.failUnlessEqual(data["read"][0]["length"], 120)
+            self.failUnlessEqual(data["segment"][0]["segment_length"], 100)
+            self.failUnlessEqual(data["segment"][2]["segment_number"], 2)
+            self.failUnlessEqual(data["segment"][2]["finish_time"], None)
+            phwr_id = base32.b2a(hashutil.tagged_hash("foo", "serverid_a")[:20])
+            cmpu_id = base32.b2a(hashutil.tagged_hash("foo", "serverid_b")[:20])
+            # serverids[] keys are strings, since that's what JSON does, but
+            # we'd really like them to be ints
+            self.failUnlessEqual(data["serverids"]["0"], "phwr")
+            self.failUnlessEqual(data["serverids"]["1"], "cmpu")
+            self.failUnlessEqual(data["server_info"][phwr_id]["short"], "phwr")
+            self.failUnlessEqual(data["server_info"][cmpu_id]["short"], "cmpu")
+            self.failUnless("dyhb" in data)
+            self.failUnless("misc" in data)
         d.addCallback(_check_dl_json)
         d.addCallback(lambda res: self.GET("/status/up-%d" % ul_num))
         def _check_ul(res):
diff --git a/src/allmydata/web/download-status-timeline.xhtml b/src/allmydata/web/download-status-timeline.xhtml
new file mode 100644
index 0000000..ff893db
--- /dev/null
+++ b/src/allmydata/web/download-status-timeline.xhtml
@@ -0,0 +1,34 @@
+<html xmlns:n="http://nevow.com/ns/nevow/0.1">
+  <head>
+    <title>AllMyData - Tahoe - File Download Status Timeline</title>
+    <link href="/tahoe_css" rel="stylesheet" type="text/css"/>
+    <link href="/webform_css" rel="stylesheet" type="text/css"/>
+    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+    <script type="text/javascript" src="/jquery.js"></script>
+    <script type="text/javascript" src="/protovis-d3.2.js"></script>
+    <script type="text/javascript" src="/download_status_timeline.js"></script>
+  </head>
+  <body>
+
+<h1>File Download Status</h1>
+
+<ul>
+  <li>Started: <span n:render="started"/></li>
+  <li>Storage Index: <span n:render="si"/></li>
+  <li>Helper?: <span n:render="helper"/></li>
+  <li>Total Size: <span n:render="total_size"/></li>
+  <li>Progress: <span n:render="progress"/></li>
+  <li>Status: <span n:render="status"/></li>
+</ul>
+
+
+<div style="">
+  <a id="zoomin" href="#">ZOOMIN</a> <a id="zoomout" href="#">ZOOMOUT</a>
+  <div id="overview" style="float:right;width:166px;height:100px; border: 1px solid #ddd">overview</div>
+  <div id="timeline" style="width:600px;border: 1px solid #aaa">Timeline</div>
+</div>
+
+<div>Return to the <a href="/">Welcome Page</a></div>
+
+  </body>
+</html>
diff --git a/src/allmydata/web/download-status.xhtml b/src/allmydata/web/download-status.xhtml
index 30abfca..b3560ed 100644
--- a/src/allmydata/web/download-status.xhtml
+++ b/src/allmydata/web/download-status.xhtml
@@ -16,6 +16,7 @@
   <li>Total Size: <span n:render="total_size"/></li>
   <li>Progress: <span n:render="progress"/></li>
   <li>Status: <span n:render="status"/></li>
+  <li><span n:render="timeline_link"/></li>
 </ul>
 
 <div n:render="events"></div>
diff --git a/src/allmydata/web/download_status_timeline.js b/src/allmydata/web/download_status_timeline.js
new file mode 100644
index 0000000..e5150e9
--- /dev/null
+++ b/src/allmydata/web/download_status_timeline.js
@@ -0,0 +1,184 @@
+
+$(function() {
+
+      function onDataReceived(data) {
+          var bounds = { min: data.bounds.min,
+                         max: data.bounds.max
+                       };
+          //bounds.max = data.dyhb[data.dyhb.length-1].finish_time;
+          var duration = bounds.max - bounds.min;
+          var WIDTH = 600;
+          var vis = new pv.Panel().canvas("timeline").margin(30);
+
+          var dyhb_top = 0;
+          //var read_top = dyhb_top + 30*data.dyhb.length+60;
+          var read_top = dyhb_top + 30*pv.max(data.dyhb,
+                                              function(d) {return d.row;})+60;
+          var segment_top = read_top + 30*data.read[data.read.length-1].row+60;
+          var misc_top = segment_top + 30*data.segment[data.segment.length-1].row+60;
+          var block_top = misc_top + 50;
+          var block_row_to_y = {};
+          var row_y=0;
+          for (var group=0; group < data.block_rownums.length; group++) {
+              for (var row=0; row < data.block_rownums[group]; row++) {
+                  block_row_to_y[group+"-"+row] = row_y;
+                  row_y += 10;
+              }
+              row_y += 5;
+          }
+          var height = block_top + row_y;
+
+          var kx = bounds.min;
+          var ky = 1;
+          var x = pv.Scale.linear(bounds.min, bounds.max).range(0, WIDTH-40);
+          var relx = pv.Scale.linear(0, duration).range(0, WIDTH-40);
+          //var y = pv.Scale.linear(-ky,ky).range(0, height);
+          //x.nice(); relx.nice();
+
+          /* add the invisible panel now, at the bottom of the stack, so that
+          it won't steal mouseover events and prevent tooltips from
+          working. */
+          var zoomer = vis.add(pv.Panel)
+              .events("all")
+              .event("mousedown", pv.Behavior.pan())
+              .event("mousewheel", pv.Behavior.zoom())
+              .event("pan", transform)
+              .event("zoom", transform)
+          ;
+
+          vis.anchor("top").top(-20).add(pv.Label).text("DYHB Requests");
+
+          vis.add(pv.Bar)
+              .data(data.dyhb)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "shnums: "+d.response_shnums;})
+              .fillStyle(function(d){return data.server_info[d.serverid].color;})
+              .strokeStyle("black").lineWidth(1)
+          .anchor("left").add(pv.Label).text(function(d){return d.serverid.slice(0,4);})
+          ;
+
+          vis.add(pv.Rule)
+              .data(data.dyhb)
+              .top(function(d){return 30*d.row + 20/2;})
+              .left(0).width(0)
+              .strokeStyle("#888")
+              .anchor("left").add(pv.Label)
+              .text(function(d){return d.serverid.slice(0,4);})
+          ;
+
+          /* we use a function for data=relx.ticks() here instead of
+           simply .data(relx.ticks()) so that it will be recalculated when
+           the scales change (by pan/zoom) */
+          var xaxis = vis.add(pv.Rule)
+              .data(function() {return relx.ticks();})
+              .strokeStyle("#ccc")
+              .left(relx)
+              .anchor("bottom").add(pv.Label)
+              .text(function(d){return relx.tickFormat(d)+"s";});
+
+          var read = vis.add(pv.Panel).top(read_top);
+          read.anchor("top").top(-20).add(pv.Label).text("read() requests");
+
+          read.add(pv.Bar)
+              .data(data.read)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "read(start="+d.start+", len="+d.length+") -> "+d.bytes_returned+" bytes";})
+              .fillStyle("red")
+              .strokeStyle("black").lineWidth(1);
+
+          var segment = vis.add(pv.Panel).top(segment_top);
+          segment.anchor("top").top(-20).add(pv.Label).text("segment() requests");
+
+          segment.add(pv.Bar)
+              .data(data.segment)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "seg"+d.segment_number+" ["+d.segment_start+":+"+d.segment_length+"] (took "+(d.finish_time-d.start_time)+")";})
+              .fillStyle(function(d){if (d.success) return "#c0ffc0";
+                                    else return "#ffc0c0";})
+              .strokeStyle("black").lineWidth(1)
+              .anchor("center").add(pv.Label).text(function(d){return d.segment_number;});
+
+          var block = vis.add(pv.Panel).top(block_top);
+          block.anchor("top").top(-20).add(pv.Label).text("block requests");
+
+          var shnum_colors = pv.Colors.category10();
+          block.add(pv.Bar)
+              .data(data.block)
+              .height(10)
+              .top(function (d) {return block_row_to_y[d.row[0]+"-"+d.row[1]];})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "sh"+d.shnum+"-on-"+d.serverid.slice(0,4)+" ["+d.start+":+"+d.length+"] -> "+d.response_length;})
+              .fillStyle(function(d){return data.server_info[d.serverid].color;})
+              .strokeStyle(function(d){return shnum_colors(d.shnum).color;})
+              .lineWidth(function(d)
+                         {if (d.response_length > 100) return 3;
+                         else return 1;
+                          })
+          ;
+
+          var misc = vis.add(pv.Panel).top(misc_top);
+          misc.anchor("top").top(-20).add(pv.Label).text("misc");
+          misc.add(pv.Bar)
+              .data(data.misc)
+              .height(20)
+              .top(function(d){return 25*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d)
+                     {return "start="+d.start_time+"  finish="+d.finish_time+"  duration="+(d.finish_time-d.start_time);})
+              .fillStyle("#eee")
+              .strokeStyle("#444")
+          .anchor("top").add(pv.Label).text(function(d){return d.what;})
+          ;
+
+
+          vis.height(height);
+
+          function zoomin() {
+              var t = zoomer.transform().invert();
+              t.k = t.k/1.5;
+              zoomer.transform(t.invert());
+              zoompan(t);
+          }
+
+          function zoomout() {
+              var t = zoomer.transform().invert();
+              t.k = t.k*1.5;
+              zoomer.transform(t.invert());
+              zoompan(t);
+          }
+
+          function transform() {
+              var t = this.transform().invert();
+              zoompan(t);
+          }
+          function zoompan(t) {
+              // when t.x=0 and t.k=1.0, left should be bounds.min
+              x.domain(bounds.min + (t.x/WIDTH)*duration,
+                       bounds.min + t.k*duration + (t.x/WIDTH)*duration);
+              relx.domain(0 + t.x/WIDTH*duration,
+                          t.k*duration + (t.x/WIDTH)*duration);
+              vis.render();
+          }
+
+          vis.render();
+          $("#zoomin").click(zoomin);
+          $("#zoomout").click(zoomout);
+      }
+
+      $.ajax({url: "event_json",
+              method: 'GET',
+              dataType: 'json',
+              success: onDataReceived });
+});
+
diff --git a/src/allmydata/web/root.py b/src/allmydata/web/root.py
index 3af15d9..14a83e4 100644
--- a/src/allmydata/web/root.py
+++ b/src/allmydata/web/root.py
@@ -164,6 +164,12 @@ class Root(rend.Page):
         self.child_named = FileHandler(client)
         self.child_status = status.Status(client.get_history())
         self.child_statistics = status.Statistics(client.stats_provider)
+        def f(name):
+            return nevow_File(resource_filename('allmydata.web', name))
+        self.putChild("jquery.js", f("jquery.js"))
+        self.putChild("download_status_timeline.js", f("download_status_timeline.js"))
+        self.putChild("protovis-r3.2.js", f("protovis-r3.2.js"))
+        self.putChild("protovis-d3.2.js", f("protovis-d3.2.js"))
 
     def child_helper_status(self, ctx):
         # the Helper isn't attached until after the Tub starts, so this child
